Unit HTCDEU0;

Interface

CONST
  maxLines    = 23;
  maxChars    = 76;
  maxButton   = 35;

TYPE
  textStr     = String[maxChars];
  buttonTag   = String[maxButton];
  fileNameStr = String[67];
  colorSpecs  = (textB, textF, bordB, bordF, buttonB, buttonF,
                 hiLiteB, hiLiteF);
  colors      = Array[colorSpecs] Of Byte;
  borders     = (noBord, singleBord, doublebord, singleUp, doubleUp);
  buttonRec   = Record
                  tag        : buttonTag;
                  xCoord,
                  yCoord     : Byte;
                  fileLoc    : Integer;
                End;

  dpPtr       = ^dbRec;
  dbRec       = Record
                  Case Byte Of
                  0 : (HTCVers      : Real;
                       defColors    : colors;
                       defBord      : borders);
                  1 : (tag          : buttonTag;
                       frameColors  : colors;
                       frameBord    : borders;
                       frameWidth,
                       frameLines   : Byte;
                       buttonCount  : Byte;
                       recdCount    : Byte;
                       tFileName    : String[12]);
                  2 : (winText      : textStr;);
                  3 : (button1,
                       button2      : buttonRec);
                  End;

  idxRec      = Record
                  tag        : buttonTag;
                  fileLoc    : Integer;
                End;

  dbFile      = File Of dbRec;
  idxFile     = File Of idxRec;
  sourceFile  = Text;

Implementation
Begin
End.

